#include "xwin.h"

Display *display;
int screen;
Window window;
GC gc;
XFontStruct *xfs, *text_fs;
int win_width, win_height;

int grays[16]; /* 0 is bg, 15 is fg */

Window rootwin;
Colormap cmap;

static Atom delete_atom, wm_protocols_atom;

void
xinit()
{
  display = XOpenDisplay(0);
  screen = XDefaultScreen(display);
  rootwin = XDefaultRootWindow(display);
  cmap = XDefaultColormap(display, screen);

  XColor pix;
  int *gammas;
  int i;

  Visual *visual = XDefaultVisual(display, screen);
  XVisualInfo vi, *vip;
  vi.visualid = XVisualIDFromVisual(visual);
  vip = XGetVisualInfo (display, VisualIDMask, &vi, &i);

  for (i=0; i<16; i++)
    {
      pix.red = pix.green = pix.blue = 65535 - i * 65535 / 15;
      XAllocColor(display, cmap, &pix);
      grays[i] = pix.pixel;
    }

  window = XCreateSimpleWindow(display,
			       rootwin,
			       0, 0,
			       160, 240,
			       0,
			       0,
			       grays[0]);
  win_width = 160;
  win_height = 240;

  XMapWindow (display, window);
  XFlush(display);
  gc = XCreateGC(display, window, 0, 0);
  XSetForeground(display, gc, grays[15]);
  XSetBackground(display, gc, grays[0]);
#if 0
  if (WhitePixel(display, screen) == 0)
    XSetFunction(display, gc, GXor);
  else if (!(WhitePixel(display, screen) & (WhitePixel(display, screen)+1)))
    XSetFunction(display, gc, GXand);
#endif

  XSetWindowAttributes attributes;
  attributes.event_mask = (  ExposureMask
			   | ButtonPressMask
			   | ButtonReleaseMask
			   | ButtonMotionMask
			   | PointerMotionHintMask
			   | KeyPressMask );
  XChangeWindowAttributes(display, window, CWEventMask, &attributes);

  delete_atom = XInternAtom(display, "WM_DELETE_WINDOW", 0);
  wm_protocols_atom = XInternAtom(display, "WM_PROTOCOLS", 0);

  XSetWMProtocols(display, window, &delete_atom, 1);

  xfs = XLoadQueryFont(display, "6x10");
  if (!xfs)
    xfs = XLoadQueryFont(display, "fixed");
  XSetFont(display, gc, xfs->fid);
}

void xwin_event(XEvent *e)
{
  XNextEvent(display, e);
  if (e->type == ClientMessage)
    {
      if (e->xclient.message_type == wm_protocols_atom
	  && e->xclient.data.l[0] == delete_atom)
	exit(0);
    }
  if (e->type == MotionNotify)
    {
      int root_x, root_y, pos_x, pos_y;
      Window root, child;
      unsigned int keys_buttons;
      if (XQueryPointer(display, e->xmotion.window,
			 &root, &child, &root_x, &root_y,
			 &pos_x, &pos_y, &keys_buttons))
	{
	  XEvent tmp;
	  XCheckWindowEvent(display, e->xmotion.window,
			    PointerMotionMask|PointerMotionHintMask|ButtonMotionMask
			    |Button1MotionMask|Button2MotionMask|Button3MotionMask,
			    &tmp);
	  e->xmotion.x = pos_x;
	  e->xmotion.y = pos_y;
	}
    }
}
